]> git.sesse.net Git - backup.sh/blobdiff - backup.sh
Englishify a bit.
[backup.sh] / backup.sh
index ac038ede42efdf24b02f809abe052d129aa39994..307a14f23aae338f15b76d4c795aa0823ccdd180 100755 (executable)
--- a/backup.sh
+++ b/backup.sh
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
 # backup.sh
 # 
 # Backup up Unix-like computers
 # mind when hacking:
 #
 # KISS. And by that I mean really simple. Only regular Unix commands, please
-# (but GNU extensions are used).
+# (but GNU extensions are used and moreutils has to be installed).
 #
 # Because of the way we run this script from cron, informational logging goes
 # to stderr and warnings and errors to stdout. This way, we get mail whenever
 # stuff fails, and other output is redirected to the log file.
 # 
-# The computers are backed up in parallell (but the filesystems on each
-# computer in serial). This is implemented highly simplistic, with forking
-# subshells. The script has no concept about threads, and stuff might go wrong,
-# which usually requires manual cleanups.
-#
 # The script is halfway Norwegian and halfway English. Newer modifications are
 # in English, we should probably stick to that.
-# 
-# Known issues:
-#
-# o $R has no proper meaning because of the forking subshell stuff. We need a
-#   more robust way of returning non-zero on errors, which we probably don't
-#   right now.
-#
+
+# The computer to backup.
+computer=$1
 
 # Configuration
-LOCKFILE=/home/backup/backuprun.lockfile
+LOCKFILE=/home/backup/backuprun.lockfile.$computer
 confdir=/home/backup/conf/              # Configuration files
 storagedir=/backup                      # Where we keep backups
 maksantallfulle=3                       # Number of full backups
@@ -49,15 +40,15 @@ DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
 exclude=$confdir/exclude
 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
 
-# Initially, we consider everything to be just fine.
-R=0
+if [ -z "$computer" ]; then
+       echo "Usage: $0 COMPUTER"
+       exit 1
+fi
 
 # Die more or less gracefully (at least notify user)
 die() {
-       echo `date`": Something nasty happened, and since I fork a lot:"
-        echo `date`": I CANNOT CLEAN UP THE MESS MYSELF."
-       echo `date`": You need to get rid of lost process named stuff like $0, tar and ssh."
-       exit 255
+       echo `date`": Something nasty happened. Ending, and not deleting lockfile $LOCKFILE."
+       exit 1
 }
 
 # Trap C-c and kill
@@ -72,111 +63,103 @@ fi;
 touch $LOCKFILE
 echo $$ > $LOCKFILE
 
-#syntax of remotestat:
-#hostname:/directory/
-remotestatf=$confdir/remotestat
-[ -f $remotestatf ] && remotestat=`cat $remotestatf`
-###
-
-PATH=/local/bin:$PATH:/store/bin
-export PATH
-
 echo `date`": Backup run starting" >&2
 
 umask 027
 
-# The computers we want to back up
-unixcomputers=`cat $confdir/computers.unix \
-  | grep -v "^#" \
-  | grep -v "^$" `
 
-# Backup only one computer, from command line?
-if [ $1 ] ; then 
-  unixcomputers=$1
-fi;
-
-
-#selve backupen
-# krever at noen variabler er satt
-# krever at vi er i rett katalog
 backup()
 {
 
  echo -n `date` >&2
  printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
 
- if [ "$backuplevel" = "daglig" ] || [ "$backuplevel" = "incremental" ]
+ SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
+ incrementalsnar="/root/.backup/${sfilesystem}.snar"
+ if [ "$backuplevel" = "daglig" ]
  then
-  lastd=`cat ../.date`
-  lastcmd="--newer='$lastd'"
+   # If incremental backup, we need to copy the incremental status to $computer.
+   # If it does not exist, whine a bit and then run date-based instead.
+   if [ -s "$SNARFILE" ]; then
+     if ! scp $SNARFILE root@$computer:$incrementalsnar; then
+       echo `date`" $computer: Could not copy .incremental.snar to $computer"
+       die
+     fi
+     lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
+   else
+     echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
+     incrementalsnar=""
+     lastd=`cat ../.date`
+     lastcmd="--newer='$lastd'"
+   fi
  else
-  lastcmd=""
- fi
-
- #if this client has a special tar
- #we need to find a better solution to this conf-issue
- if [ -f $confdir/tar.$computer ] ; then
-   tar=`cat $confdir/tar.$computer`
- else 
-   tar=tar
+    lastcmd="--listed-incremental=$incrementalsnar"
  fi
 
  # expand the exclude-path for use with tar
  exf=`ssh root@$computer "ls ~/.backup/exclude"`
 
  # We try to run tar on the remote computer
- #    z gzip it
  #    c create archive
  #    C change to directory first
  #    . where to start taring (see C)
  #    $lastcmd only files newer than this
  #    --one-file-system don't traverse file systems
+ #    --use-compress-program compress it using gzip or pigz
  #    --exclude-from file to get exclusion pattern from
  #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
  #    file and build a file list, respectivly.  
  TARFILE=$DATE.tmp
- TARCMD="ssh root@$computer \"$tar --one-file-system -zcf - -C $filesystem . $lastcmd \
+ TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
        --exclude-from=$exf\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
  echo `date`" $computer: Running $TARCMD" >&2
  eval $TARCMD > $DATE.idx
 
- if [ -s $TARFILE ]; then
-  # File is >0 in size, we assume it worked.
+ if [ $? -eq 0 ] && [ -s $TARFILE ]; then
+  # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
+
+  if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
+    echo `date`" $computer: Could not copy .incremental.snar from $computer"
+    die
+  fi
 
   # Move tar file in place
   mv $TARFILE $DATE.tgz
+  mv $SNARFILE.tmp $SNARFILE
 
   # Update timestamp
   echo $DATEs > ../.date && touch -t $DATE ../.date
 
-  # Make a sorted filelist as well
+  # Make a sorted file list as well
   sort -k6 < $DATE.idx > $DATE.sdx
 
   # Fix permissions
   chmod 600 *tgz                      #only for us
   chmod 644 *sdx *idx 2>/dev/null     #everyone can read
 
+  # Let the remote computer know that we ran a successful backup (for nagios)
+  ssh root@$computer touch $filesystem/.lastbackup
+
  else
   # Something wrong happened.
   rm $TARFILE
   echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
-
-  # We don't want to return 0
-  R=1
+  die
  fi
 
 }
 
-for computer in $unixcomputers
-do
-( 
  # Check that the target filesystem is mounted (actually check that it's not
  # the root filesystem)
+ if [ ! -d "$storagedir/$computer" ]; then
+       echo `date`" $computer: Target filesystem ($storagedir/$computer) does not exist. Aborting"
+       die
+ fi
  rootfilesystem=`df -P /`
  targetfilesystem=`df -P "$storagedir/$computer"`
  if [ "$rootfilesystem" == "$targetfilesystem" ]; then
        echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
-       continue
+       die
  fi
 
  echo `date`" $computer: Backing up $computer" >&2
@@ -184,15 +167,17 @@ do
  # Try to SSH to the computer without entering a password.
  if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
   echo `date`" $computer: Could not use passwordless SSH."
+  die
+ fi
 
-  # We don't want to return 0
-  R=1
-  # Do next computer
-  continue;
+ # Check if pigz is available
+ if ssh -n root@$computer "pigz -V 2>/dev/null"; then
+   compressor=pigz
+ else
+   echo `date`" $computer: pigz missing; falling back to gzip."
+   compressor=gzip
  fi
  
- filesystems=""
-
  # Check dump bit in fstab
  filesystems=`ssh -n root@$computer "cat /etc/fstab" \
   | grep -v nfs \
@@ -202,39 +187,34 @@ do
 
  # Clean up our dir at this client
  if ! ssh root@$computer "rm -r ~/.backup ; mkdir -m 700 ~/.backup"; then
-  echo `date`" $computer: Could not create backup staging area at $computer:~/.backup - skipping backup of $computer"
-  R=1
-  continue;
+  echo `date`" $computer: Could not create backup staging area at $computer:~/.backup"
+  die
  fi
 
  # Try to copy $exclude to $computer
  if ! scp $exclude root@$computer:~/.backup/exclude > /dev/null; then
-  echo `date`" $computer: Could not copy exclude.txt to $computer - skipping backup of $computer"
-  R=1
-  continue;
+  echo `date`" $computer: Could not copy exclude.txt to $computer"
+  die
  fi
 
  # Try to copy preeexec and postexec if they exist
  if [ -f $confdir/preexec.$computer ]; then
    if ! scp $confdir/preexec.$computer  root@$computer:~/.backup/preexec >&2; then
-     echo `date`" $computer: Could not copy preexec.$computer to $computer:~/.backup/preexec - skipping backup of $computer"
-     R=1
-     continue
+     echo `date`" $computer: Could not copy preexec.$computer to $computer:~/.backup/preexec"
+     die
    fi
  fi
  if [ -f $confdir/postexec.$computer ]; then
    if ! scp $confdir/postexec.$computer root@$computer:~/.backup/postexec >&2; then
-     echo `date`" $computer: Could not copy postexec.$computer to $computer:~/.backup/postexec - skipping backup of $computer"
-     R=1
-     continue
+     echo `date`" $computer: Could not copy postexec.$computer to $computer:~/.backup/postexec"
+     die
    fi
  fi
 
- # Try to run preexec if it exist
+ # Try to run preexec if it exists
  if ! ssh root@$computer "[ ! -f ~/.backup/preexec ] || /bin/bash -x ~/.backup/preexec" >&2; then
-       echo `date`" $computer: Could not run $computer:~/.backup/preexec - skipping backup of $computer"
-       R=1
-       continue
+       echo `date`" $computer: Could not run $computer:~/.backup/preexec"
+       die
  fi
 
 
@@ -244,9 +224,8 @@ do
   sfilesystem=`echo $filesystem | tr '\/\$' '__'`
 
   # Prepare storage area
-  mkdir -m 755 -p $storagedir/$computer/$sfilesystem/{full,daglig} 2>/dev/null
-  echo $filesystem > ${storagedir}/${computer}/.${sfilesystem}.name 
-  chmod 644 ${storagedir}/${computer}/.${sfilesystem}.name
+  mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
+  mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
 
   # Default backuplevel
   backuplevel=daglig
@@ -259,7 +238,6 @@ do
   fi
 
   # Check if we want a full backup
-  printf " $computer $filesystem: $confdir/fastfullbackupdag.$computer.$sfilesystem\n"
   if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
     fullbackup_min_for_this_machine=$dagermellomfulleforfast
     if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
@@ -312,23 +290,8 @@ do
  # Try to run postexec if it exist
  if ! ssh root@$computer "[ ! -f ~/.backup/postexec ] || /bin/bash -x ~/.backup/postexec" >&2; then
        echo `date`" $computer: Could not run $computer:~/.backup/postexec"
-       R=1
+       die
  fi
 
-) &
-done
-
-wait
-
 # Remove lockfile
 rm $LOCKFILE
-
-# Did anything go wrong?
-# (IMPORTANT NOTE: The R-business does not work as expected, since this script
-# forks itself).
-if [ $R != 0 ]; then
-       echo `date`": Backup run ended with errors, check logs."
-       exit 1
-else
-       echo `date`": Backup run ended" >&2
-fi